VERSION 5.00
Begin VB.Form RunDistance 
   Caption         =   "Run Distance Analysis Engine"
   ClientHeight    =   2496
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   3744
   LinkTopic       =   "Form1"
   ScaleHeight     =   2496
   ScaleWidth      =   3744
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtCommandFile 
      Height          =   372
      Left            =   1980
      TabIndex        =   4
      Text            =   "dstIn.tmp"
      Top             =   420
      Width           =   1452
   End
   Begin VB.TextBox txtResultCode 
      Height          =   372
      Left            =   2100
      TabIndex        =   1
      Top             =   1800
      Width           =   1332
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Run Engine"
      Height          =   492
      Left            =   840
      TabIndex        =   0
      Top             =   1200
      Width           =   1692
   End
   Begin VB.Label Label2 
      Caption         =   "Command file to run:"
      Height          =   372
      Left            =   240
      TabIndex        =   3
      Top             =   420
      Width           =   1572
   End
   Begin VB.Label Label1 
      Caption         =   "Result code:"
      Height          =   372
      Left            =   420
      TabIndex        =   2
      Top             =   1800
      Width           =   1332
   End
End
Attribute VB_Name = "RunDistance"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'RunDistance example VB app
'Contains code to run the Distance analysis engine
'The main function here is RunEngine

'Uses calls to the Windows API to create the analysis engine process,
' wait for it to finish and then get the result code

'This version assumes that D4.exe is in the same directory as this
' program -- but that is easily changed

'Written by Len Thomas 5/12/2003
'Feel free to use/modify/etc as you see fit!

'-----------------------------------------
'Module level definitions
'-----------------------------------------

Option Explicit

'Name of analysis engine
Const mstrENGINE_FILE = "D4.exe"
'Mode 0 = run engine (mode 1 = import -- you probably won't want this!)
Const mlngMODE = 0
' Maximum allowed path length including path, filename,
Private Const mintMAX_PATH_LEN = 260

' API Constants and Declarations
' More than you need here -- some are left over from other options
' that are possible!
Private Const SYNCHRONIZE = &H100000
Private Const INFINITE = &HFFFFFFFF
Private Const DEBUG_PROCESS = &H1
Private Const DEBUG_ONLY_THIS_PROCESS = &H2
Private Const CREATE_SUSPENDED = &H4
Private Const DETACHED_PROCESS = &H8
Private Const CREATE_NEW_CONSOLE = &H10
Private Const NORMAL_PRIORITY_CLASS = &H20
Private Const IDLE_PRIORITY_CLASS = &H40
Private Const HIGH_PRIORITY_CLASS = &H80
Private Const REALTIME_PRIORITY_CLASS = &H100
Private Const CREATE_NEW_PROCESS_GROUP = &H200
Private Const CREATE_NO_WINDOW = &H8000000
Private Const WAIT_FAILED = -1&
Private Const WAIT_OBJECT_0 = 0
Private Const WAIT_ABANDONED = &H80&
Private Const WAIT_ABANDONED_0 = &H80&
Private Const WAIT_TIMEOUT = &H102&
Private Const STARTF_USESHOWWINDOW = &H1
Private Const STARTF_USESTDHANDLES = &H100
Private Const SW_HIDE = 0
Private Const SW_SHOW = 5
Private Const SW_MINIMIZE = 6
Private Const WM_CLOSE = &H10
Private Const STILL_ACTIVE = &H103&

Private Type PROCESS_INFORMATION
        hProcess As Long
        hThread As Long
        dwProcessId As Long
        dwThreadId As Long
End Type
Private Type STARTUPINFO
        cb As Long
        lpReserved As String
        lpDesktop As String
        lpTitle As String
        dwX As Long
        dwY As Long
        dwXSize As Long
        dwYSize As Long
        dwXCountChars As Long
        dwYCountChars As Long
        dwFillAttribute As Long
        dwFlags As Long
        wShowWindow As Integer
        cbReserved2 As Integer
        lpReserved2 As Long
        hStdInput As Long
        hStdOutput As Long
        hStdError As Long
End Type

Private Declare Function OpenProcess Lib "kernel32" (ByVal dwDesiredAccess As Long, ByVal bInheritHandle As Long, ByVal dwProcessId As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function CreateProcess Lib "kernel32" Alias "CreateProcessA" (ByVal lpApplicationName As String, ByVal lpCommandLine As String, ByVal lpProcessAttributes As Long, ByVal lpThreadAttributes As Long, ByVal bInheritHandles As Long, ByVal dwCreationFlags As Long, lpEnvironment As Any, ByVal lpCurrentDirectory As String, lpStartupInfo As STARTUPINFO, lpProcessInformation As PROCESS_INFORMATION) As Long
Private Declare Function WaitForInputIdle Lib "user32" (ByVal hProcess As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function GetExitCodeProcess Lib "kernel32" (ByVal hProcess As Long, lpExitCode As Long) As Long
Private Declare Function TerminateProcess Lib "kernel32" (ByVal hProcess As Long, ByVal uExitCode As Long) As Long
Private Declare Function IsWindow Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function PostMessage Lib "user32" Alias "PostMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Function GetShortPathName Lib "kernel32" Alias "GetShortPathNameA" (ByVal lpszLongPath As String, ByVal lpszShortPath As String, ByVal cchBuffer As Long) As Long

'-----------------------------------------
'Private functions
'-----------------------------------------

Private Function RunEngine() As Long
'Purpose: Runs the Distance analysis engine, with the input file
' specified in txtCommandFile and then waits for it to finish
' Returns:
'   1 if the analysis ran OK
'   2 if there were warnings
'   3 if there were errors
'   4 if there was a file error (e.g., couldn't find the data file)
'   some large number if the analysis engine crashed
'  -1 if there was some problem starting the analysis engine, or
'       an unexpected error
    
    On Error GoTo ErrHandler
    
    Dim hProcess As Long 'ProcessID for the analysis
    Dim res As Long 'General var used for storing return codes
    
    'Required by CreateProcess
    Dim pinfo As PROCESS_INFORMATION
    Dim sinfo As STARTUPINFO
    sinfo.cb = Len(sinfo)
    sinfo.lpReserved = vbNullString
    sinfo.lpDesktop = vbNullString
    sinfo.lpTitle = vbNullString
    sinfo.dwFlags = STARTF_USESHOWWINDOW
    'This line hides the analysis engine
    sinfo.wShowWindow = SW_HIDE
    'If you want to see the engine running, use
    'sinfo.wShowWindow = SW_SHOW
    'There are lots of other options too (such as running minimized, etc)
    
    'Turn the cursor to an hourglass
    Me.MousePointer = vbHourglass
    
    'Make up command line
    Dim strCommandLine As String
    'Use 8.3 version of app.path as create process cannot cope
    ' with long filenames.
    'Assumes D4.exe is in the current directory - could easily
    ' modify to point to c:\program files\distance4\ or wherever
    Dim strShortAppPath As String
    strShortAppPath = ShortPathName(App.Path)
    strCommandLine = _
        strShortAppPath & "\" & mstrENGINE_FILE & " " & _
        mlngMODE & ", " & Trim(txtCommandFile)
    
    'Create the process
    res = CreateProcess(vbNullString, _
        strCommandLine, _
        0, 0, True, NORMAL_PRIORITY_CLASS, ByVal 0&, vbNullString, _
        sinfo, pinfo)
    'Check it worked - returns non0 if ok
    If (res = 0) Then GoTo ErrHandler
    
    'Let the process initialize
    Call WaitForInputIdle(pinfo.hProcess, INFINITE)
    
    'Close the thread hanle
    Call CloseHandle(pinfo.hThread)
    hProcess = pinfo.hProcess
    'Another check
    If hProcess = 0 Then GoTo ErrHandler

    'Wait until the analysis has finished
    ' the INFINITE here means wait forever, until
    ' it has finished running
    res = WaitForSingleObject(hProcess, INFINITE)
    Select Case res
        
        Case WAIT_OBJECT_0
            
            'Process has finished
            'Get the exit code (1 = OK, 2=warnings, etc)
            Dim lngStatus As Long
            res = GetExitCodeProcess(hProcess, lngStatus)
            If res = 0 Then GoTo ErrHandler
            'Return the exit code
            RunEngine = lngStatus
        
        Case WAIT_FAILED
            
            'Something went wrong!
            GoTo ErrHandler
        
        Case Else
            'Something unexpected!
            GoTo ErrHandler
    End Select
    
    'Turn the cursor to normal
    Me.MousePointer = vbNormal
    
    Exit Function

ErrHandler:
    'There's been a problem so return -1
    RunEngine = -1
    'Turn the cursor to normal
    Me.MousePointer = vbNormal
End Function

Private Function ShortPathName(Optional Path As String = "", _
    Optional FileName As String = "") As String
'Returns the short path + file name for the file FileName
' DOES NOT CHECK THAT THE FILE EXISTS (unlike FullPathName).
' If the path is >260 chars or has a problem then returns ""
'Inputs:
' Path contains path to file, with or without final "\".  Can be either
'  long or short format.  If it is not included, then assumes
'  current directory
' FileName contains name of file.  If not included, then returns path
'  without filename.

'IMPORTANT NOTE: Doesn't work if a filename is specified that is not already
' in short form -- e.g., C:\temp\test file.txt will return ""

    'Contains either the path or path+filename passed in
    Dim strLongPath As String
    
    If (FileName = "") Then
        If Path = "" Then
            ShortPathName = ""
            Exit Function
        Else
            strLongPath = Path
        End If
    Else
        'Add path if it is used
        If (Path = "") Then
            strLongPath = FileName
        Else
            'Check for final slash
            If Right(Path, 1) = "\" Then
                strLongPath = Path
            Else
                strLongPath = Path & "\"
            End If
            strLongPath = strLongPath & FileName
        End If
    End If
        
    'Get short form
    Dim nRet As Long
    Dim nBufferLength As Long
    Dim lpBuffer As String * mintMAX_PATH_LEN
    nBufferLength = mintMAX_PATH_LEN
    nRet = GetShortPathName(strLongPath, lpBuffer, nBufferLength)
    If (nRet = 0) Or (nRet > mintMAX_PATH_LEN) Then
        ShortPathName = ""
    Else
        'Trim off trailing blanks and /0 chars
        ShortPathName = Left(lpBuffer, nRet)
    End If

End Function

'-----------------------------------------
'Events
'-----------------------------------------

Private Sub cmdStart_Click()
    txtResultCode.Text = RunEngine
End Sub
